// SplitCmdLine.cpp: CSplitCmdLine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SplitCmdLine.h"
#include "MainAr.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSplitCmdLine::CSplitCmdLine()
{
	m_argc = 0;
	m_argv = NULL;
	m_lpCmdLine = NULL;
	m_lpBaseDirectory = NULL;
	m_bHide = FALSE;
	m_bSfx = FALSE;
}

CSplitCmdLine::~CSplitCmdLine()
{
	if (m_lpCmdLine)
		free(m_lpCmdLine);
	if (m_argv)
		free(m_argv);
}

BOOL CSplitCmdLine::Split(const char* lpCmdLine)
{
	// R}hC
	if (lpCmdLine)
		m_lpCmdLine = _strdup(lpCmdLine);
	else
		m_lpCmdLine = _strdup("");
	char* p = m_lpCmdLine;
	char* pStart;
	while (*p)
	{
		while (*p == ' ')
		{
			*p = '\0';
			++p;
		}
		if (*p == '\"')
		{
			pStart = p;
			++p;
			while (*p && !(*p == '\"' && (p[1] == ' ' || p[1] == '\0')))
				++p;
			if (*p == '\0')
				break;
			*pStart = '\0';
			*p = '\0';
			++p;
			++m_argc;
		}
		else if (*p != '\0')
		{
			while (*p && *p != ' ')
				++p;
			++m_argc;
		}
	}
	
	// R}hC蓖
	int i;
	m_argv = (char**)malloc((m_argc + 1) * sizeof(char*));
	p = m_lpCmdLine;
	for (i = 0; i < m_argc; ++i)
	{
		while (*p == NULL)
			++p;
		if (!_stricmp(p, "-hide") || !_stricmp(p, "/hide"))
		{
			// \[h
			m_bHide = TRUE;
			--m_argc;
			--i;
		}
		else if (!_stricmp(p, "-sfx") || !_stricmp(p, "/sfx"))
		{
			// SFX쐬
			m_bSfx = TRUE;
			--m_argc;
			--i;
		}
		else if (IsBaseDir(p))
		{
			// fBNgݒ
			m_lpBaseDirectory = p;
			--m_argc;
			--i;
		}
		else
			m_argv[i] = p;
		while (*p)
			++p;
	}
	m_argv[i] = "";

	if (*m_argv[0] == 'l' || *m_argv[0] == 't')
	{
		m_bHide = TRUE;
	}
	return TRUE;
}

// fBNg
BOOL CSplitCmdLine::IsBaseDir(const char* lpOption)
{
	if (*lpOption == '-' || *lpOption == '/')
		return FALSE;

	const char* p = lpOption + strlen(lpOption) - 1;
	if (*p == '\\' &&  _ismbstrail((PBYTE)lpOption, (PBYTE)p) == 0)
		return TRUE;

	return FALSE;
}
